package cn.cslg.report.common.utils;

import cn.cslg.report.common.model.BaseVO;
import cn.dev33.satoken.secure.SaSecureUtil;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.stream.Collectors;

@Component
public class DataUtils {
    @Resource
    private CacheUtils cacheUtils;

    //秘钥
    public static final String PASSWORD_KEY = "835a9bdc-4f9f-4614-a0cc-493a12454156";

    /**
     * 分页查询设置返回参数 （当前页 每页条数 总条数）
     */
    public static BaseVO setPageColumn(int size, int current, int total) {
        BaseVO baseVO = new BaseVO();
        baseVO.setCurrent(current)
                .setSize(size)
                .setTotal(total);
        return baseVO;
    }

    /**
     * 对称加密
     */
    public static String aesEncrypt(String password) {
        return SaSecureUtil.aesEncrypt(PASSWORD_KEY, password);
    }

    /**
     * 对称解密
     */
    public static String aesDecrypt(String password) {
        return SaSecureUtil.aesDecrypt(PASSWORD_KEY, password);
    }

    /**
     * @return 1.对比数据库内减少了那些数据 2.对比数据库内改变了那些数据(新增 修改) 3.两份数组中不变的数据
     * @author 沈永艺
     * @description 计算数据库内已有数据List 和 前台传入新的数据List 之间的比较
     */
    public static Map<String, List<Integer>> compareTwoList(List<Integer> dbList, List<Integer> frontList) {
        //创建一个存放比对结果的Map 数组
        Map<String, List<Integer>> comparisonResults = new HashMap<>();
        //减少
        List<Integer> reduce = dbList.stream().filter(item -> !frontList.contains(item)).collect(Collectors.toList());
        //改变
        List<Integer> change = frontList.stream().filter(item -> !dbList.contains(item)).collect(Collectors.toList());
        //不变
        List<Integer> unChange = dbList.stream().filter(frontList::contains).collect(Collectors.toList());
        //填充数据
        comparisonResults.put("reduce", reduce);
        comparisonResults.put("change", change);
        comparisonResults.put("unChange", unChange);
        return comparisonResults;
    }

    /**
     * @return 去重后的数据
     * @author 沈永艺
     * @description 在对象数组中按照某一类属性进行去重
     */
    //用例：待去重List.stream().filter(DataUtils.distinctByKey(对象::get属性字段)).collect(Collectors.toList());
    public static <T> Predicate<T> distinctByKey(Function<? super T, ?> keyExtractor) {
        Map<Object, Boolean> seen = new ConcurrentHashMap<>();
        return t -> seen.putIfAbsent(keyExtractor.apply(t), Boolean.TRUE) == null;
    }

    /**
     * @return 计算完成度
     * @author 沈永艺
     * @description 输入完成数量和全部数量计算完成百分比
     */
    public String calculateCompletion(Integer finishNum, Integer allNum) {
        return finishNum / allNum + "%";
    }

    /**
     * @return 拆分出的特征
     * @author 沈永艺
     * @description 处理权利要求
     */
    // TODO: 2022/11/2 未完成
    public List<String> processRightToFeatures(List<String> rightList, String patentNo) {
        List<String> features = new ArrayList<>();
        if (patentNo != null) {
            String country = patentNo.substring(0, 2);
            if (country.equals("CN") || country.equals("JP")) {

            } else {

            }
        }

        return features;
    }


    /**
     * 比较两个字符串的相识度
     * 核心算法：用一个二维数组记录每个字符串是否相同，如果相同记为0，不相同记为1，每行每列相同个数累加
     * 则数组最后一个数为不相同的总数，从而判断这两个字符的相识度
     *
     * @param str
     * @param target
     * @return
     */
    private static int compare(String str, String target) {
        int d[][];              // 矩阵
        int n = str.length();
        int m = target.length();
        int i;                  // 遍历str的
        int j;                  // 遍历target的
        char ch1;               // str的
        char ch2;               // target的
        int temp;               // 记录相同字符,在某个矩阵位置值的增量,不是0就是1
        if (n == 0) {
            return m;
        }
        if (m == 0) {
            return n;
        }
        d = new int[n + 1][m + 1];
        // 初始化第一列
        for (i = 0; i <= n; i++) {
            d[i][0] = i;
        }
        // 初始化第一行
        for (j = 0; j <= m; j++) {
            d[0][j] = j;
        }
        for (i = 1; i <= n; i++) {
            // 遍历str
            ch1 = str.charAt(i - 1);
            // 去匹配target
            for (j = 1; j <= m; j++) {
                ch2 = target.charAt(j - 1);
                if (ch1 == ch2 || ch1 == ch2 + 32 || ch1 + 32 == ch2) {
                    temp = 0;
                } else {
                    temp = 1;
                }
                // 左边+1,上边+1, 左上角+temp取最小
                d[i][j] = min(d[i - 1][j] + 1, d[i][j - 1] + 1, d[i - 1][j - 1] + temp);
            }
        }
        return d[n][m];
    }


    /**
     * 获取最小的值
     */
    private static int min(int one, int two, int three) {
        return (one = one < two ? one : two) < three ? one : three;
    }

    /**
     * 获取两字符串的相似度
     */
    public static float getSimilarityRatio(String str, String target) {
        int max = Math.max(str.length(), target.length());
        return 1 - (float) compare(str, target) / max;

    }
}
